Traveling by Stagecoach
Time Limit: 2000MS   Memory Limit: 65536K
Total Submissions: 3407   Accepted: 1322   Special Judge

Description

Once upon a time, there was a traveler.

He plans to travel using stagecoaches (horse wagons). His starting point and destination are fixed, but he cannot determine his route. Your job in this problem is to write a program which determines the route for him.

There are several cities in the country, and a road network connecting them. If there is a road between two cities, one can travel by a stagecoach from one of them to the other. A coach ticket is needed for a coach ride. The number of horses is specified in each of the tickets. Of course, with more horses, the coach runs faster.

At the starting point, the traveler has a number of coach tickets. By considering these tickets and the information on the road network, you should find the best possible route that takes him to the destination in the shortest time. The usage of coach tickets should be taken into account.

The following conditions are assumed.

  • A coach ride takes the traveler from one city to another directly connected by a road. In other words, on each arrival to a city, he must change the coach.
  • Only one ticket can be used for a coach ride between two cities directly connected by a road.
  • Each ticket can be used only once.
  • The time needed for a coach ride is the distance between two cities divided by the number of horses.
  • The time needed for the coach change should be ignored.

Input

The input consists of multiple datasets, each in the following format. The last dataset is followed by a line containing five zeros (separated by a space).

n m p a b 
t1 t2 ... tn 
x1 y1 z1 
x2 y2 z2 
... 
xp yp zp

Every input item in a dataset is a non-negative integer. If a line contains two or more input items, they are separated by a space.

n is the number of coach tickets. You can assume that the number of tickets is between 1 and 8. m is the number of cities in the network. You can assume that the number of cities is between 2 and 30. p is the number of roads between cities, which may be zero.

a is the city index of the starting city. b is the city index of the destination city. a is not equal to b. You can assume that all city indices in a dataset (including the above two) are between 1 and m.

The second line of a dataset gives the details of coach tickets. ti is the number of horses specified in the i-th coach ticket (1<=i<=n). You can assume that the number of horses is between 1 and 10.

The following p lines give the details of roads between cities. The i-th road connects two cities with city indices xi and yi, and has a distance zi (1<=i<=p). You can assume that the distance is between 1 and 100.

No two roads connect the same pair of cities. A road never connects a city with itself. Each road can be traveled in both directions.

Output

For each dataset in the input, one line should be output as specified below. An output line should not contain extra characters such as spaces.

If the traveler can reach the destination, the time needed for the best route (a route with the shortest time) should be printed. The answer should not have an error greater than 0.001. You may output any number of digits after the decimal point, provided that the above accuracy condition is satisfied.

If the traveler cannot reach the destination, the string "Impossible" should be printed. One cannot reach the destination either when there are no routes leading to the destination, or when the number of tickets is not sufficient. Note that the first letter of "Impossible" is in uppercase, while the other letters are in lowercase.

Sample Input

3 4 3 1 4
3 1 2
1 2 10
2 3 30
3 4 20
2 4 4 2 1
3 1
2 3 3
1 3 3
4 1 2
4 2 5
2 4 3 4 1
5 5
1 2 10
2 3 10
3 4 10
1 2 0 1 2
1
8 5 10 1 5
2 7 1 8 4 5 6 3
1 2 5
2 3 4
3 4 7
4 5 3
1 3 25
2 4 23
3 5 22
1 4 45
2 5 51
1 5 99
0 0 0 0 0

Sample Output

30.000
3.667
Impossible
Impossible
2.856

Hint

Since the number of digits after the decimal point is not specified, the above result is not the only solution. For example, the following result is also acceptable.

30.0

3.66667

Impossible

Impossible

2.85595

题目链接:POJ 2686

刷白书上的题目看到的,由于一条边只能走一次,在DAG的最短路中本来就是只走一次,那么只要再用一个状态表示走到某一个点用了哪些车票就好了。

用dis[v][S]表示走到v这个点,n张车票使用状态为S,显然一开始在点a,用了0张车票,因此初始状态为(a, 0),然后SPFA之后根据$[dis[b], dis[b] + (1 << n) - 1]$中的最小值判断即可,一开始边数写小了RE了几次……

代码:

#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <sstream>
#include <numeric>
#include <cstring>
#include <bitset>
#include <string>
#include <deque>
#include <stack>
#include <cmath>
#include <queue>
#include <set>
#include <map>
using namespace std;
#define INF 0x3f3f3f3f
#define LC(x) (x<<1)
#define RC(x) ((x<<1)+1)
#define MID(x,y) ((x+y)>>1)
#define CLR(arr,val) memset(arr,val,sizeof(arr))
#define FAST_IO ios::sync_with_stdio(false);cin.tie(0);
typedef pair<int, int> pii;
typedef long long LL;
const double PI = acos(-1.0);
const int N = 15;
const int MAX_V = 35;
const int MAX_E = MAX_V * MAX_V;
struct edge
{
int to, nxt;
double dx;
edge() {}
edge(int _to, int _nxt, double _dx): to(_to), nxt(_nxt), dx(_dx) {}
};
edge E[MAX_E << 1];
int head[MAX_V], tot;
double dis[MAX_V][1 << N];
int vis[MAX_V][1 << N];
double ti[N]; void init()
{
CLR(head, -1);
tot = 0;
}
void add(int s, int t, double dx)
{
E[tot] = edge(t, head[s], dx);
head[s] = tot++;
}
void spfa(int s, int n)
{
queue<pii>Q;
for (int i = 0; i < MAX_V; ++i)
fill(dis[i], dis[i] + (1 << N), 1e9);
CLR(vis, 0);
Q.push(pii(s, 0));
vis[s][0] = 1;
dis[s][0] = 0;
while (!Q.empty())
{
int u = Q.front().first;
int t = Q.front().second;
Q.pop();
vis[u][t] = 0;
for (int i = head[u]; ~i; i = E[i].nxt)
{
int v = E[i].to;
for (int j = 0; j < n; ++j)
{
if (t & (1 << j))
continue;
int V = (t | (1 << j));
double dx = E[i].dx / ti[j];
if (dis[v][V] > dis[u][t] + dx)
{
dis[v][V] = dis[u][t] + dx;
if (!vis[v][V])
{
vis[v][V] = 1;
Q.push(pii(v, V));
}
}
}
}
}
}
int main(void)
{
int n, m, p, a, b, i, x, y, z;
while (~scanf("%d%d%d%d%d", &n, &m, &p, &a, &b) && (n | m | p | a | b))
{
init();
for (i = 0; i < n; ++i)
{
scanf("%lf", &ti[i]);
}
for (i = 0; i < p; ++i)
{
scanf("%d%d%d", &x, &y, &z);
add(x, y, z * 1.0);
add(y, x, z * 1.0);
}
spfa(a, n);
double ans = *min_element(dis[b], dis[b] + (1 << n) + 1);
ans == 1e9 ? puts("Impossible") : printf("%.3f\n", ans);
}
return 0;
}

最新文章

  1. HTTP状态码及其含义
  2. java基础知识回顾之java Thread类学习(十一)--join方法的理解
  3. mysql ERROR 1044 (42000): Access denied for user &#39;&#39;@&#39;localhost&#39; to database
  4. A+B问题通解_Pascal_C++_Java
  5. PHP运行方式对比
  6. JS学习笔记——标准对象
  7. POJ_3143 验证“歌德巴赫猜想”
  8. LayoutInflater作用及使用--自定义EditText,自带清除内容按钮
  9. cf702A Maximum Increase
  10. MySql 学习笔记 (派生表)
  11. 如何判断NSDictionary是否包含某个键
  12. 阿里聚安全&#183;安全周刊】一种秘密窃取数据的新型 Android 木马|iOS 11相机惊现BUG
  13. []转帖] 浅谈Linux下的五种I/O模型
  14. Android几行代码实现监听微信聊天
  15. Charles maplocal 时中文显示乱码问题
  16. 如何搭建eclipse+maven环境
  17. php正则验证邮箱、手机号、姓名、身份证、特殊符号等
  18. hdu 2437(dfs)
  19. VERIFY DATABASE 正在异常终止。 (Microsoft SQL Server,错误: 3169)
  20. &lt;Android 基础(十八)&gt; XLIFF

热门文章

  1. Count Numbers(矩阵快速幂)
  2. 第七章 动态创建HTML内容
  3. 修改android studio中的avd sdk路径、avd sdk找不到的解决方案
  4. 按格式读取csv文件内容
  5. React后台管理系统-登录页面
  6. nginx反向代理与正向代理的区别
  7. sql 参数化查询
  8. form中 单选框 input[type="radio"] 分组
  9. 分享自己写的基于Dapper的轻量级ORM框架~
  10. PHP 对象基础知识